int XX(void) {
	php_printf("Hello world");
	return 1;
}
void mysdl_error(const char *msg) {
	if (MYGLOBALS(show_sdl_errors)) {
		php_error(E_WARNING,"function:%s, error in %s: SDL Error: %s",
			get_active_function_name(TSRMLS_C),msg,SDL_GetError());
	}
}
//SDL_Rect->Array.
static void rect2array(SDL_Rect *r, zval *a)
{
	array_init(a);
	add_assoc_long(a, "x", r->x);
	add_assoc_long(a, "y", r->y);
	add_assoc_long(a, "w", r->w);
	add_assoc_long(a, "h", r->h);
}
//SDL_PixelFormat -> Array 
static void pf2array(SDL_PixelFormat *pixelformat, zval *pixelformat_array TSRMLS_DC)
{
	zval *palette, *colors, *color;
	int handle, i;

	handle = zend_list_insert(pixelformat, le_pixelformat);
	
	array_init(pixelformat_array);
	add_assoc_resource(pixelformat_array, "handle", handle);
	zend_list_addref(handle);

	add_assoc_long(pixelformat_array, "BitsPerPixel", pixelformat->BitsPerPixel);
	add_assoc_long(pixelformat_array, "BytesPerPixel", pixelformat->BytesPerPixel);
	add_assoc_long(pixelformat_array, "Rmask", pixelformat->Rmask);
	add_assoc_long(pixelformat_array, "Gmask", pixelformat->Gmask);
	add_assoc_long(pixelformat_array, "Bmask", pixelformat->Bmask);
	add_assoc_long(pixelformat_array, "Amask", pixelformat->Amask);
	add_assoc_long(pixelformat_array, "Rshift", pixelformat->Rshift);
	add_assoc_long(pixelformat_array, "Gshift", pixelformat->Gshift);
	add_assoc_long(pixelformat_array, "Bshift", pixelformat->Bshift);
	add_assoc_long(pixelformat_array, "Ashift", pixelformat->Ashift);
	add_assoc_long(pixelformat_array, "Rloss", pixelformat->Rloss);
	add_assoc_long(pixelformat_array, "Gloss", pixelformat->Gloss);
	add_assoc_long(pixelformat_array, "Bloss", pixelformat->Bloss);
	add_assoc_long(pixelformat_array, "Aloss", pixelformat->Aloss);
	add_assoc_long(pixelformat_array, "colorkey", pixelformat->colorkey);
	add_assoc_long(pixelformat_array, "alpha", pixelformat->alpha);

	if (pixelformat->palette == NULL) {
		add_assoc_null(pixelformat_array, "palette");
	} else {
		MAKE_STD_ZVAL(palette);
		array_init(palette);
		MAKE_STD_ZVAL(colors);
		add_assoc_long(palette, "ncolors", pixelformat->palette->ncolors);
		array_init(colors);
	
		for(i=0; i < pixelformat->palette->ncolors; i++)
		{
			MAKE_STD_ZVAL(color);
			array_init(color);
			add_assoc_long(color, "r", pixelformat->palette->colors[i].r);
			add_assoc_long(color, "g", pixelformat->palette->colors[i].g);
			add_assoc_long(color, "b", pixelformat->palette->colors[i].b);
			add_next_index_zval(colors, color);
		}
		add_assoc_zval(palette, "colors", colors);
		add_assoc_zval(pixelformat_array, "palette", palette);
	}
}

// SDL_Surface -> Array
static void surf2array(SDL_Surface *surface, zval *surface_array TSRMLS_DC)
{
	zval *format, *rect;
	int handle;

	handle = zend_list_insert(surface, le_surface);

	array_init(surface_array);
	add_assoc_resource(surface_array, "handle", handle);
	zend_list_addref(handle);

	add_assoc_long(surface_array, "flags", surface->flags);
	add_assoc_long(surface_array, "w", surface->w);
	add_assoc_long(surface_array, "h", surface->h);
	add_assoc_long(surface_array, "pitch", surface->pitch);
	add_assoc_long(surface_array, "refcount", surface->refcount);

	MAKE_STD_ZVAL(format);
	pf2array(surface->format, format TSRMLS_CC);
	add_assoc_zval(surface_array, "format", format);

	MAKE_STD_ZVAL(rect);
	rect2array(&surface->clip_rect, rect);
	add_assoc_zval(surface_array, "clip_rect", rect);
}

static void videoinfo2array(SDL_VideoInfo *from, zval *to TSRMLS_DC) {
	zval *fmt;
	array_init(to);
	
	add_assoc_long(to, "hw_available", from->hw_available);
	add_assoc_long(to, "wm_available", from->wm_available);
	add_assoc_long(to, "blit_hw", from->blit_hw);
	add_assoc_long(to, "blit_hw_CC", from->blit_hw_CC);
	add_assoc_long(to, "blit_hw_A", from->blit_hw_A);
	add_assoc_long(to, "blit_sw", from->blit_sw);
	add_assoc_long(to, "blit_sw_CC", from->blit_sw_CC);
	add_assoc_long(to, "blit_sw_A", from->blit_sw_A);
	add_assoc_long(to, "blit_fill", from->blit_fill);
	add_assoc_long(to, "video_mem", from->video_mem);

	MAKE_STD_ZVAL(fmt);
	pf2array(from->vfmt, fmt TSRMLS_CC);
	add_assoc_zval(to, "vfmt", fmt);
}
static int getArrayValue(zval **array, const char *key, zval ***dest) {
	if (zend_hash_find(array, key, sizeof(*key), (void **)(*dest)) == FAILURE) {
		php_error(E_WARNING, "%s() unable to find %s in array",
				  get_active_function_name(TSRMLS_C),key);
		return (1==0);
	} 
	return (1==1);
}

